#!/usr/bin/env python

"""
Additional program AST nodes.

Copyright (C) 2006, 2007 Paul Boddie <paul@boddie.org.uk>

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 3 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
details.

You should have received a copy of the GNU General Public License along with
this program.  If not, see <http://www.gnu.org/licenses/>.
"""

class Self:

    """
    A program node encapsulating object/context information in an argument list.
    This is not particularly like Attribute, Class, Instance or other such
    things, since it actually appears in the program representation.
    """

    def __init__(self, attribute):
        self.types = set()
        self.types.add(attribute)

class Op:

    "A replacement AST node representing an operation in a Compare construct."

    def __init__(self, name, expr):
        self.name = name
        self.expr = expr

# vim: tabstop=4 expandtab shiftwidth=4
